' set time and date in a DS3231 
' Bob D 2014 03 11

' dependencies : MMBasic Time$ and Date$ must be set first

' DS3231 I2C address
RTCaddr = &h68
' DS3231 register 0
RegAddr0 = 0

' get seconds
x = VAL(RIGHT$(TIME$, 2))
seconds = (x\10)*16 + x mod 10

' get minutes
x = VAL(MID$(TIME$, 4, 2))
minutes = (x\10)*16 + x mod 10

' get hours
x = VAL(LEFT$(TIME$, 2))
hours = (x\10)*16 + x mod 10

' get day of month
dd = VAL(LEFT$(DATE$, 2))
DoM = (dd\10)*16 + dd mod 10

' get month
mm = VAL(MID$(DATE$, 4, 2))
month = (mm\10)*16 + mm mod 10

' get year
yy = VAL(RIGHT$(DATE$, 2))
year = (yy\10)*16 + yy mod 10

' get day of the week
yyyy = VAL(RIGHT$(DATE$, 4))
a = (14-mm)\12
m = mm + 12*a - 2 
y = yyyy - a 
DoW = (dd + y + y\4 - y\100 + y\400 + 31*m\12) mod 7 + 1

I2Cen 100,100
I2Csend RTCaddr, 0, 8, RegAddr0,seconds,minutes,hours,DoW,DoM,month,year
If MM.I2C <> 0 then 
  print "I2C error = "; MM.I2C
  end
Endif
I2Cdis

End



